from django.db import models
from django.urls.base import reverse_lazy
from django.utils.safestring import mark_safe
from tinymce.models import HTMLField
from db.help import buttons_help_text


# Create your models here.


class TournamentPage(models.Model):
    name = models.CharField('Nazwa', max_length=250)
    published = models.BooleanField('Turniej opublikowany', default=False)

    header = HTMLField('Nagłówek', default='', blank=True)
    footer = HTMLField('Stopka', default='', blank=True)

    homepage_rename = models.CharField('Nazwa przycisku', default='Strona główna', max_length=250)
    homepage = HTMLField('Strona główna', default='', blank=True)
    homepage_buttons = models.TextField(
        'Przyciski', default='', blank=True, help_text=buttons_help_text)

    schedule_and_results_rename = models.CharField('Nazwa przycisku', default='Harmonogram i wyniki', max_length=250)
    schedule_and_results = HTMLField(
        'Harmonogram i wyniki', default='', blank=True)
    schedule_and_results_enabled = models.BooleanField(
        'Strona włączona', default=False)
    schedule_and_results_buttons = models.TextField(
        'Przyciski', default='', blank=True, help_text=buttons_help_text)

    registration_rename = models.CharField('Nazwa przycisku', default='Rejestracja', max_length=250)
    registration = HTMLField('Rejestracja', default='', blank=True)
    registration_enabled = models.BooleanField(
        'Strona włączona', default=False)
    registration_buttons = models.TextField(
        'Przyciski', default='', blank=True, help_text=buttons_help_text)

    rules_rename = models.CharField('Nazwa przycisku', default='Regulamin', max_length=250)
    rules = HTMLField('Regulamin', default='', blank=True)
    rules_enabled = models.BooleanField('Strona włączona', default=False)
    rules_buttons = models.TextField(
        'Przyciski', default='', blank=True, help_text=buttons_help_text)

    fee_and_prizes_rename = models.CharField('Nazwa przycisku', default='Wpisowe i nagrody', max_length=250)
    fee_and_prizes = HTMLField('Wpisowe i nagrody', default='', blank=True)
    fee_and_prizes_enabled = models.BooleanField(
        'Strona włączona', default=False)
    fee_and_prizes_buttons = models.TextField(
        'Przyciski', default='', blank=True, help_text=buttons_help_text)

    accomodation_rename = models.CharField('Nazwa przycisku', default='Noclegi', max_length=250)
    accomodation = HTMLField('Noclegi', default='', blank=True)
    accomodation_enabled = models.BooleanField(
        'Strona włączona', default=False)
    accomodation_buttons = models.TextField(
        'Przyciski', default='', blank=True, help_text=buttons_help_text)

    contact_rename = models.CharField('Nazwa przycisku', default='Kontakt', max_length=250)
    contact = HTMLField('Kontakt', default='', blank=True)
    contact_enabled = models.BooleanField('Strona włączona', default=False)
    contact_buttons = models.TextField(
        'Przyciski', default='', blank=True, help_text=buttons_help_text)

    class Meta:
        verbose_name = 'Strona turnieju'
        verbose_name_plural = 'Strony turniejów'

    @property
    def link(self):
        href = reverse_lazy('homepage', args=[self.id])
        return mark_safe(f'<a href="{href}" target="_blank">{href}</a>')

    def __str__(self):
        return self.name
